/* rygel-lms-all-music.c generated by valac 0.56.9, the Vala compiler
 * generated from rygel-lms-all-music.vala, do not modify */

/*
 * Copyright (C) 2013 Intel Corporation.
 *
 * Author: Jussi Kukkonen <jussi.kukkonen@intel.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "rygel-lms.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sqlite3.h>
#include "rygel-server.h"
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#define RYGEL_LMS_ALL_MUSIC_SQL_ALL_TEMPLATE "SELECT files.id, files.path, files.size, " "audios.title as title, audios.trackno, audios.length, " "audios.channels, audios.sampling_rate, audios.bitrate, " "audios.dlna_profile, audios.dlna_mime, " "audio_artists.name as artist, " "audio_albums.name, " "files.mtime, " "audio_genres.name " "FROM audios, files " "LEFT JOIN audio_artists " "ON audios.artist_id = audio_artists.id " "LEFT JOIN audio_albums " "ON audios.album_id = audio_albums.id " "LEFT JOIN audio_genres " "ON audios.genre_id = audio_genres.id " "WHERE dtime = 0 AND audios.id = files.id %s " "LIMIT ? OFFSET ?;"
#define RYGEL_LMS_ALL_MUSIC_SQL_COUNT "SELECT COUNT(audios.id) " "FROM audios, files " "WHERE dtime = 0 AND audios.id = files.id;"
#define RYGEL_LMS_ALL_MUSIC_SQL_COUNT_WITH_FILTER_TEMPLATE "SELECT COUNT(audios.id), audios.title as title, " "audio_artists.name as artist " "FROM audios, files " "LEFT JOIN audio_artists " "ON audios.artist_id = audio_artists.id " "WHERE dtime = 0 AND audios.id = files.id %s;"
#define RYGEL_LMS_ALL_MUSIC_SQL_FIND_OBJECT "SELECT files.id, files.path, files.size, " "audios.title, audios.trackno, audios.length, " "audios.channels, audios.sampling_rate, audios.bitrate, " "audios.dlna_profile, audios.dlna_mime, " "audio_artists.name, " "audio_albums.name, " "files.mtime, " "audio_genres.name " "FROM audios, files " "LEFT JOIN audio_artists " "ON audios.artist_id = audio_artists.id " "LEFT JOIN audio_albums " "ON audios.album_id = audio_albums.id " "LEFT JOIN audio_genres " "ON audios.genre_id = audio_genres.id " "WHERE dtime = 0 AND files.id = ? AND audios.id = files.id;"
#define RYGEL_LMS_ALL_MUSIC_SQL_ADDED "SELECT files.id, files.path, files.size, " "audios.title as title, audios.trackno, audios.length, " "audios.channels, audios.sampling_rate, audios.bitrate, " "audios.dlna_profile, audios.dlna_mime, " "audio_artists.name as artist, " "audio_albums.name, " "files.mtime, " "audio_genres.name " "FROM audios, files " "LEFT JOIN audio_artists " "ON audios.artist_id = audio_artists.id " "LEFT JOIN audio_albums " "ON audios.album_id = audio_albums.id " "LEFT JOIN audio_genres " "ON audios.genre_id = audio_genres.id " "WHERE dtime = 0 AND audios.id = files.id " "AND update_id > ? AND update_id <= ?;"
#define RYGEL_LMS_ALL_MUSIC_SQL_REMOVED "SELECT files.id, files.path, files.size, " "audios.title as title, audios.trackno, audios.length, " "audios.channels, audios.sampling_rate, audios.bitrate, " "audios.dlna_profile, audios.dlna_mime, " "audio_artists.name as artist, " "audio_albums.name, " "files.mtime, " "audio_genres.name " "FROM audios, files " "LEFT JOIN audio_artists " "ON audios.artist_id = audio_artists.id " "LEFT JOIN audio_albums " "ON audios.album_id = audio_albums.id " "LEFT JOIN audio_genres " "ON audios.genre_id = audio_genres.id " "WHERE dtime <> 0 AND audios.id = files.id " "AND update_id > ? AND update_id <= ?;"

enum  {
	RYGEL_LMS_ALL_MUSIC_0_PROPERTY,
	RYGEL_LMS_ALL_MUSIC_NUM_PROPERTIES
};
static GParamSpec* rygel_lms_all_music_properties[RYGEL_LMS_ALL_MUSIC_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

static gpointer rygel_lms_all_music_parent_class = NULL;

static gchar* rygel_lms_all_music_real_get_sql_all_with_filter (RygelLMSCategoryContainer* base,
                                                         const gchar* filter);
static gchar* rygel_lms_all_music_real_get_sql_count_with_filter (RygelLMSCategoryContainer* base,
                                                           const gchar* filter);
static RygelMediaObject* rygel_lms_all_music_real_object_from_statement (RygelLMSCategoryContainer* base,
                                                                  sqlite3_stmt* statement);
static GType rygel_lms_all_music_get_type_once (void);

static gchar*
rygel_lms_all_music_real_get_sql_all_with_filter (RygelLMSCategoryContainer* base,
                                                  const gchar* filter)
{
	RygelLMSAllMusic * self;
	gint _tmp0_;
	gint _tmp1_;
	gchar* filter_str = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 115 "../src/plugins/lms/rygel-lms-all-music.vala"
	self = (RygelLMSAllMusic*) base;
#line 115 "../src/plugins/lms/rygel-lms-all-music.vala"
	g_return_val_if_fail (filter != NULL, NULL);
#line 116 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp0_ = strlen (filter);
#line 116 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp1_ = _tmp0_;
#line 116 "../src/plugins/lms/rygel-lms-all-music.vala"
	if (_tmp1_ == 0) {
#line 85 "rygel-lms-all-music.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 117 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp2_ = rygel_lms_category_container_get_sql_all ((RygelLMSCategoryContainer*) self);
#line 117 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp3_ = _tmp2_;
#line 117 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 117 "../src/plugins/lms/rygel-lms-all-music.vala"
		result = _tmp4_;
#line 117 "../src/plugins/lms/rygel-lms-all-music.vala"
		return result;
#line 99 "rygel-lms-all-music.c"
	}
#line 120 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp5_ = g_strdup_printf ("AND %s", filter);
#line 120 "../src/plugins/lms/rygel-lms-all-music.vala"
	filter_str = _tmp5_;
#line 122 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp6_ = filter_str;
#line 122 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp7_ = g_strdup_printf (RYGEL_LMS_ALL_MUSIC_SQL_ALL_TEMPLATE, _tmp6_);
#line 122 "../src/plugins/lms/rygel-lms-all-music.vala"
	result = _tmp7_;
#line 122 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (filter_str);
#line 122 "../src/plugins/lms/rygel-lms-all-music.vala"
	return result;
#line 115 "rygel-lms-all-music.c"
}

static gchar*
rygel_lms_all_music_real_get_sql_count_with_filter (RygelLMSCategoryContainer* base,
                                                    const gchar* filter)
{
	RygelLMSAllMusic * self;
	gint _tmp0_;
	gint _tmp1_;
	gchar* filter_str = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 125 "../src/plugins/lms/rygel-lms-all-music.vala"
	self = (RygelLMSAllMusic*) base;
#line 125 "../src/plugins/lms/rygel-lms-all-music.vala"
	g_return_val_if_fail (filter != NULL, NULL);
#line 126 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp0_ = strlen (filter);
#line 126 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp1_ = _tmp0_;
#line 126 "../src/plugins/lms/rygel-lms-all-music.vala"
	if (_tmp1_ == 0) {
#line 140 "rygel-lms-all-music.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 127 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp2_ = rygel_lms_category_container_get_sql_count ((RygelLMSCategoryContainer*) self);
#line 127 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp3_ = _tmp2_;
#line 127 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 127 "../src/plugins/lms/rygel-lms-all-music.vala"
		result = _tmp4_;
#line 127 "../src/plugins/lms/rygel-lms-all-music.vala"
		return result;
#line 154 "rygel-lms-all-music.c"
	}
#line 130 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp5_ = g_strdup_printf ("AND %s", filter);
#line 130 "../src/plugins/lms/rygel-lms-all-music.vala"
	filter_str = _tmp5_;
#line 132 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp6_ = filter_str;
#line 132 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp7_ = g_strdup_printf (RYGEL_LMS_ALL_MUSIC_SQL_COUNT_WITH_FILTER_TEMPLATE, _tmp6_);
#line 132 "../src/plugins/lms/rygel-lms-all-music.vala"
	result = _tmp7_;
#line 132 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (filter_str);
#line 132 "../src/plugins/lms/rygel-lms-all-music.vala"
	return result;
#line 170 "rygel-lms-all-music.c"
}

static RygelMediaObject*
rygel_lms_all_music_real_object_from_statement (RygelLMSCategoryContainer* base,
                                                sqlite3_stmt* statement)
{
	RygelLMSAllMusic * self;
	gint id = 0;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* mime_type = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	gchar* title = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* song_id = NULL;
	gchar* _tmp12_;
	RygelMusicItem* song = NULL;
	RygelMusicItem* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GDateTime* dt = NULL;
	GDateTime* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	GFile* file = NULL;
	const gchar* _tmp24_;
	GFile* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	RygelMediaObject* result;
#line 135 "../src/plugins/lms/rygel-lms-all-music.vala"
	self = (RygelLMSAllMusic*) base;
#line 135 "../src/plugins/lms/rygel-lms-all-music.vala"
	g_return_val_if_fail (statement != NULL, NULL);
#line 137 "../src/plugins/lms/rygel-lms-all-music.vala"
	id = sqlite3_column_int (statement, 0);
#line 138 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp0_ = (const gchar*) sqlite3_column_text (statement, 1);
#line 138 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 138 "../src/plugins/lms/rygel-lms-all-music.vala"
	path = _tmp1_;
#line 139 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp2_ = (const gchar*) sqlite3_column_text (statement, 10);
#line 139 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 139 "../src/plugins/lms/rygel-lms-all-music.vala"
	mime_type = _tmp3_;
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp5_ = mime_type;
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
	if (_tmp5_ == NULL) {
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp4_ = TRUE;
#line 235 "rygel-lms-all-music.c"
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp6_ = mime_type;
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp7_ = strlen (_tmp6_);
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp8_ = _tmp7_;
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp4_ = _tmp8_ == 0;
#line 248 "rygel-lms-all-music.c"
	}
#line 141 "../src/plugins/lms/rygel-lms-all-music.vala"
	if (_tmp4_) {
#line 252 "rygel-lms-all-music.c"
		const gchar* _tmp9_;
#line 143 "../src/plugins/lms/rygel-lms-all-music.vala"
		_tmp9_ = path;
#line 143 "../src/plugins/lms/rygel-lms-all-music.vala"
		g_debug ("rygel-lms-all-music.vala:143: Music item %d (%s) has no MIME type", id, _tmp9_);
#line 258 "rygel-lms-all-music.c"
	}
#line 146 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp10_ = (const gchar*) sqlite3_column_text (statement, 3);
#line 146 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 146 "../src/plugins/lms/rygel-lms-all-music.vala"
	title = _tmp11_;
#line 147 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp12_ = rygel_lms_category_container_build_child_id ((RygelLMSCategoryContainer*) self, id);
#line 147 "../src/plugins/lms/rygel-lms-all-music.vala"
	song_id = _tmp12_;
#line 148 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp13_ = rygel_music_item_new (song_id, (RygelMediaContainer*) self, title, RYGEL_MUSIC_ITEM_UPNP_CLASS);
#line 148 "../src/plugins/lms/rygel-lms-all-music.vala"
	song = _tmp13_;
#line 149 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_file_item_set_size ((RygelMediaFileItem*) song, (gint64) sqlite3_column_int (statement, 2));
#line 150 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_music_item_set_track_number (song, sqlite3_column_int (statement, 4));
#line 151 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_audio_item_set_duration ((RygelAudioItem*) song, (glong) sqlite3_column_int (statement, 5));
#line 152 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_audio_item_set_channels ((RygelAudioItem*) song, sqlite3_column_int (statement, 6));
#line 153 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_audio_item_set_sample_freq ((RygelAudioItem*) song, sqlite3_column_int (statement, 7));
#line 154 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_audio_item_set_bitrate ((RygelAudioItem*) song, sqlite3_column_int (statement, 8));
#line 155 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp14_ = (const gchar*) sqlite3_column_text (statement, 9);
#line 155 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_file_item_set_dlna_profile ((RygelMediaFileItem*) song, _tmp14_);
#line 156 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp15_ = mime_type;
#line 156 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_file_item_set_mime_type ((RygelMediaFileItem*) song, _tmp15_);
#line 157 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp16_ = (const gchar*) sqlite3_column_text (statement, 11);
#line 157 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_object_set_artist ((RygelMediaObject*) song, _tmp16_);
#line 158 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp17_ = (const gchar*) sqlite3_column_text (statement, 12);
#line 158 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_audio_item_set_album ((RygelAudioItem*) song, _tmp17_);
#line 159 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp18_ = g_date_time_new_from_unix_utc ((gint64) ((glong) sqlite3_column_int (statement, 13)));
#line 159 "../src/plugins/lms/rygel-lms-all-music.vala"
	dt = _tmp18_;
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp19_ = g_date_time_format (dt, "%Y-%m-%dT%H:%M:%S");
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp20_ = _tmp19_;
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp21_ = g_strdup_printf ("%sZ", _tmp20_);
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp22_ = _tmp21_;
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_object_set_date ((RygelMediaObject*) song, _tmp22_);
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (_tmp22_);
#line 160 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (_tmp20_);
#line 161 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp23_ = (const gchar*) sqlite3_column_text (statement, 14);
#line 161 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_object_set_genre ((RygelMediaObject*) song, _tmp23_);
#line 162 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp24_ = path;
#line 162 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp25_ = g_file_new_for_path (_tmp24_);
#line 162 "../src/plugins/lms/rygel-lms-all-music.vala"
	file = _tmp25_;
#line 163 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp26_ = g_file_get_uri (file);
#line 163 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp27_ = _tmp26_;
#line 163 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_media_object_add_uri ((RygelMediaObject*) song, _tmp27_);
#line 163 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (_tmp27_);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	result = (RygelMediaObject*) song;
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_object_unref0 (file);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_date_time_unref0 (dt);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (song_id);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (title);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (mime_type);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (path);
#line 165 "../src/plugins/lms/rygel-lms-all-music.vala"
	return result;
#line 354 "rygel-lms-all-music.c"
}

RygelLMSAllMusic*
rygel_lms_all_music_construct (GType object_type,
                               RygelMediaContainer* parent,
                               RygelLMSDatabase* lms_db)
{
	RygelLMSAllMusic * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 168 "../src/plugins/lms/rygel-lms-all-music.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 168 "../src/plugins/lms/rygel-lms-all-music.vala"
	g_return_val_if_fail (lms_db != NULL, NULL);
#line 169 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp0_ = g_strdup_printf (RYGEL_LMS_ALL_MUSIC_SQL_ALL_TEMPLATE, "");
#line 169 "../src/plugins/lms/rygel-lms-all-music.vala"
	_tmp1_ = _tmp0_;
#line 169 "../src/plugins/lms/rygel-lms-all-music.vala"
	self = (RygelLMSAllMusic*) rygel_lms_category_container_construct (object_type, "all", parent, _ ("All"), lms_db, _tmp1_, RYGEL_LMS_ALL_MUSIC_SQL_FIND_OBJECT, RYGEL_LMS_ALL_MUSIC_SQL_COUNT, RYGEL_LMS_ALL_MUSIC_SQL_ADDED, RYGEL_LMS_ALL_MUSIC_SQL_REMOVED);
#line 169 "../src/plugins/lms/rygel-lms-all-music.vala"
	_g_free0 (_tmp1_);
#line 168 "../src/plugins/lms/rygel-lms-all-music.vala"
	return self;
#line 379 "rygel-lms-all-music.c"
}

RygelLMSAllMusic*
rygel_lms_all_music_new (RygelMediaContainer* parent,
                         RygelLMSDatabase* lms_db)
{
#line 168 "../src/plugins/lms/rygel-lms-all-music.vala"
	return rygel_lms_all_music_construct (RYGEL_LMS_TYPE_ALL_MUSIC, parent, lms_db);
#line 388 "rygel-lms-all-music.c"
}

static void
rygel_lms_all_music_class_init (RygelLMSAllMusicClass * klass,
                                gpointer klass_data)
{
#line 26 "../src/plugins/lms/rygel-lms-all-music.vala"
	rygel_lms_all_music_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/plugins/lms/rygel-lms-all-music.vala"
	((RygelLMSCategoryContainerClass *) klass)->get_sql_all_with_filter = (gchar* (*) (RygelLMSCategoryContainer*, const gchar*)) rygel_lms_all_music_real_get_sql_all_with_filter;
#line 26 "../src/plugins/lms/rygel-lms-all-music.vala"
	((RygelLMSCategoryContainerClass *) klass)->get_sql_count_with_filter = (gchar* (*) (RygelLMSCategoryContainer*, const gchar*)) rygel_lms_all_music_real_get_sql_count_with_filter;
#line 26 "../src/plugins/lms/rygel-lms-all-music.vala"
	((RygelLMSCategoryContainerClass *) klass)->object_from_statement = (RygelMediaObject* (*) (RygelLMSCategoryContainer*, sqlite3_stmt*)) rygel_lms_all_music_real_object_from_statement;
#line 403 "rygel-lms-all-music.c"
}

static void
rygel_lms_all_music_instance_init (RygelLMSAllMusic * self,
                                   gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
rygel_lms_all_music_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (RygelLMSAllMusicClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_lms_all_music_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelLMSAllMusic), 0, (GInstanceInitFunc) rygel_lms_all_music_instance_init, NULL };
	GType rygel_lms_all_music_type_id;
	rygel_lms_all_music_type_id = g_type_register_static (RYGEL_LMS_TYPE_CATEGORY_CONTAINER, "RygelLMSAllMusic", &g_define_type_info, 0);
	return rygel_lms_all_music_type_id;
}

GType
rygel_lms_all_music_get_type (void)
{
	static volatile gsize rygel_lms_all_music_type_id__once = 0;
	if (g_once_init_enter (&rygel_lms_all_music_type_id__once)) {
		GType rygel_lms_all_music_type_id;
		rygel_lms_all_music_type_id = rygel_lms_all_music_get_type_once ();
		g_once_init_leave (&rygel_lms_all_music_type_id__once, rygel_lms_all_music_type_id);
	}
	return rygel_lms_all_music_type_id__once;
}

